#charset "us-ascii"
#include <adv3.h>
#include <en_us.h>

class Rebel: object
    myEnemy = Royalist
;

class Royalist: object
    myEnemy = Rebel
;

/* for the more-or-less generic soldiers, we define theName = aName,
 * but sometimes we'll want 'the so-and-so', so we provide the_Name for
 * this purpose.
 */

modify Actor
    the_Name () {
        local x = aName.find(' ');
        return 'the' + aName.substr(x); 
    }
;

class RebelArcher: Rapper, Actor, Rebel
    theName = aName   
    vocabWords = 'rebel archer*archers'
    name = 'rebel archer'
    desc = "He's a <<epithet>> rebel (pro-Matilda) archer, bearing a
           bow. "
    pluralName = 'rebel archers'    
    isEquivalent = true
    initializeActor() {
        inherited();
        local x = new Bow;
        x.moveInto(self);
        wielding = x;
        cmdDict.addWord(self, epithet, &adjective);
        aName = 'a ' + epithet + ' ' + name;
    }
    epithet = ''

    myParam = myEnemy
    myPlan = rFindAndAttack
    rIdleMessage() {

        // ideally, the following messages would vary
        callWithSenseContext(self, sight, {:"\^<<theName>> glances
                                            nervously about.\n"});
    }
;

class RebelManAtArms: Rapper, Actor, Rebel
    theName = aName    
    name = 'rebel man-at-arms'
    pluralName = 'rebel men-at-arms'
    vocabWords = 'rebel man-at-arms*men-at-arms'
    desc = "He's a rebel man-at-arms, fighting for Matilda,
           though almost certainly only for profit. "
    isEquivalent = true
    initializeActor() {
        inherited();
        local x = new Sword;
        local y = new scaleArmor;
        x.moveInto(self);
        y.moveInto(self);
        wielding = x;
        y.makeWornBy(self);
        aName = 'a ' + epithet + ' ' + name;
        cmdDict.addWord(self, epithet, &adjective);
    }
    epithet = ''

    myParam = myEnemy
    myPlan = rFindAndAttack
    level = 5
    rIdleMessage() {
        callWithSenseContext(self, sight, {:"Gripping his blade,
                               <<theName>> readies himself.\n"});
    }
;


class RoyalistArcher: Rapper, Actor, Royalist
    theName = aName
    epithet = ''
    vocabWords = 'royalist archer'
    name = 'royalist archer'
    desc = "He's a <<epithet>> royalist (pro-Stephen) archer, bearing a
           bow. "
    pluralName = 'royalist archers'
    isEquivalent = true
    initializeActor() {
        inherited();
        local x = new Bow;
        x.moveInto(self);
        wielding = x;
        aName = 'a '+ epithet + ' ' + name;
        cmdDict.addWord(self, epithet, &adjective);
    }

    myParam = myEnemy
    myPlan = rFindAndAttack
    rIdleMessage() {
        callWithSenseContext(self, sight, {:"\^<<theName>> glances
                                            nervously about.\n"});
    }
;

class RoyalistManAtArms: Rapper, Actor, Royalist
    theName = aName
    name = 'royalist man-at-arms'
    pluralName = 'royalist men-at-arms'
    vocabWords = 'royalist man-at-arms*men-at-arms'
    desc = "He's a <<epithet>> royalist man-at-arms, fighting for King
           Stephen, though in all actuality, probably fighting only for
           himself and his Baron. "
    isEquivalent = true
    initializeActor() {
        inherited();
        local x = new Sword;
        local y = new scaleArmor;
        x.moveInto(self);
        y.moveInto(self);
        wielding = x;
        y.makeWornBy(self);
        aName = 'a '+ epithet + ' ' + name;
        cmdDict.addWord(self, epithet, &adjective);
    }

    epithet = ''
    myParam = mainGate
    myPlan = rOpen
    level = 7
    rIdleMessage() {
        callWithSenseContext(self, sight, {:"Gripping his blade,
                                   <<theName>> readies himself.\n"});
    }
;

class scaleArmor: Armor
    name = 'scale armor'
    aName = 'scale armor'
    pluralName = 'suits of scale'
    vocabWords = 'suit scale armor'
    desc = "It's a tough leather jerkin riveted with scales of iron. "
    isEquivalent = true
;


//--------------**
modify northWall;
//--------------**

+rebelArcher1: RebelArcher 
  epithet = 'thin' 
;

+rebelArcher2: RebelArcher
  epithet = 'tall'
;

+rebelArcher3: RebelArcher
  epithet ='stout'
;

+rebelArcher4: RebelArcher
  epithet = 'short'
;

+rebelManAtArms1: RebelManAtArms
  epithet = 'ruddy-faced'
myPlan = rAmbush
;

+rebelManAtArms2: RebelManAtArms
  epithet = 'sturdy'
myPlan = rAmbush
;

//--------------**
modify southWall;
//--------------**

+rebelArcher5: RebelArcher
  epithet = 'bald'
;

+rebelArcher6: RebelArcher
  epithet = 'redheaded'
;

+rebelArcher7: RebelArcher
  epithet = 'blond'
;

+rebelManAtArms3: RebelManAtArms
  epithet = 'large'
myPlan = rAmbush
;

+rebelManAtArms4: RebelManAtArms
  epithet = 'small'
myPlan = rAmbush
;

//----------------**
modify battlefield;
//----------------**

+royalistManAtArms1: RoyalistManAtArms
  epithet = 'small '
;

+royalistManAtArms2: RoyalistManAtArms
  epithet = 'tall'
;

+royalistManAtArms3: RoyalistManAtArms
  epithet = 'thin'
;

+royalistManAtArms4: RoyalistManAtArms
  epithet = 'portly'
;

+royalistManAtArms5: RoyalistManAtArms
  epithet = 'sallow'
;

+royalistArcher1: RoyalistArcher
  epithet = 'swarthy'
;

+royalistArcher2: RoyalistArcher
  epithet = 'pale'
;


//----------**
modify ditch;
//----------**

+royalistManAtArms6: RoyalistManAtArms
  epithet = 'large'
;

+royalistManAtArms7: RoyalistManAtArms
  epithet = 'stout'
;

+royalistManAtArms8: RoyalistManAtArms
  epithet = 'comely'
;
++ladder1: Ladder 'wooden siege ladder' 'wooden siege ladder';

+royalistArcher3: RoyalistArcher
  epithet = 'ruddy'
;


//----------------**
modify kitchenRoof;
//----------------**

+rebelArcher8: RebelArcher
 epithet = 'swarthy'
myPlan = rAmbush
;


//---------------**
modify stableRoof;
//---------------**

+rebelArcher9: RebelArcher
 epithet = 'pallid'
myPlan = rAmbush
;

//--------------**
modify bellTower;
//--------------**

+rebelArcher10: RebelArcher
 epithet = 'pale'
myPlan = rAmbush
;

ghost: Actor
    location = hill
    desc = "You look somewhat insubstantial. "
    isGhost = true
;

myCorpse: Heavy 'your my dead saxon body/corpse/arrow/hair/face'
                 'your body'
    "Your body lies inert on the ground, an arrow sticking out of its
    chest. Your former face is already pale with death, the only sign
    of movement being when a gust of wind catches a lock of fair hair
    causing it to flap over your brow. "
    isQualifiedName = true
    specialDesc = "Your dead body lies at your feet. "
    remoteSpecialDesc(pov) {
        "Your dead body lies <<pov.getOutermostRoom.actorInPrep>> 
         <<pov.getOutermostRoom.destName>>. ";
    }
;

adelicia: Person 'young woman/adelicia' 'young woman' @chamber
    desc() {
        "She's about eighteen or nineteen years old, with high, pale
        cheekbones and long blonde hair tumbling down her back. ";
    }
    isHer = true  
    isHim = nil 
    globalParamName = 'adelicia'
;

+Wearable 'long blue dress' 'long blue dress'
    "It's a strong, deep blue colour, dyed with a dye of the sort only
    the wealthy can afford. "
    wornBy = adelicia
;

+Component 'long blonde hair/waist' 'Adelicia\'s hair'
    "{The adelicia/she}'s long blonde hair tumbles almost down to her
    waist. "
;

+AgendaItem
    initiallyActive = true
    isReady = (gPlayerChar.canHear(getActor))
    invokeItem {
        callWithSenseContext(nil, nil, 
        {:  "The young woman peers keenly towards the balcony, apparently
        alerted by the sounds of battle and anxious to know what is
        happening.\b
        <q>What's that fighting?</q> she wants to know.\b
        <q>A misguided attack on the castle, Lady Adelicia.</q> the old
        soldier tells her,
        <q>My Lord Ranulf will see them off.</q>\b
        <q>It's my father, come to rescue me!</q> she declares
        eagerly.\b
        The old soldier grasps the hilt of his sword and glowers at
        her, as if to say, <q>Don't count on it!</q><.p>" });
        isDone = true;
        adelicia.name = 'Adelicia';
        adelicia.isProperName = true;
        youngSoldier.addToAgenda(ySsympathyAgenda.setDelay(1));
    }
;


+adeliciaRescuedAgenda: AgendaItem
    initiallyActive = true
    isReady = (geoffrey.canTouch(adelicia) && ranulf.canTouch(adelicia))
    invokeItem() {
        "Ranulf scowls, <q>You will leave this keep, or your daughter
        will leave this world.</q>\b
        <q>Don't listen to him, father!</q> the brave Adelicia
        declares, <q>He wouldn't dare.</q>\n
        <q>Wouldn't I?</q> Ranulf replies, then nods to an older
        guard who puts his sword to Adelicia's breast.\b

        Geoffrey stands clenching his fists, then says, <q>You're
        beaten, Ranulf; if you so much as scratch my daughter I'll have
        each of my men flog you with knotted ropes and then I'll hang
        you myself! Submit like a beaten dog while you yet live.
        Surrender I say!</q>\b

        Ranulf stands his ground, <q>If you or your men come a step
        closer, your precious Adelicia will get more than a scratch, I
        promise you!</q>";

        inputManager.pauseForMore(); // need to flush output also!

        "As Adelicia tries to break free of her captors, the old guard
        looks as if he's about to stab her with his sword. The young
        guard tries to intervene, and takes the sword-thrust himself.
        Taking advantage of the confusion, Geoffrey springs forward and
        kill the old guard with his sword. Then, standing at his
        daughter's side, with one arm gripping his bloody sword and the
        other linked with Adelicia's, he turns to Ranulf with a thin
        smile of triumph, <q>Throw down your sword, Ranulf; I wonder
        what you're worth to Matilda? Some paltry ransom, I'm sure.</q>

        With a look of disgusted defeat, Ranulf lets his sword slip
        from his grasp. Geoffrey's men move foward to seize him. 

        The scene begins to fade before your ghostly eyes. Just before
        it vanishes, Adelicia flashes a wistful smile in your
        direction, almost as if she is aware of you and your sacrifice
        and loss -- but perhaps she was looking straight through you to
        one of her father's men. \n";

        isDone = true;
        finishGameMsg('The battle for Walcot Keep has ended, with the
             rescue of the Baron\'s daughter.', [finishOptionCredits]);
    }
;

oldSoldier: Person 'old soldier' 'old soldier' @chamber
      desc() { "The old soldier is a grey, grizzled man with a grim
               countenance and a steely manner. "; }
;

youngSoldier: Person 'young soldier' 'young soldier' @chamber
      desc() { "The young soldier is scarcely more than a boy, hardly
               needing to shave yet. "; }
;

+ySsympathyAgenda: DelayedAgendaItem
    isReady = (getActor.canTouch(gPlayerChar) && inherited)
    invokeItem {
        callWithSenseContext( nil, nil, {:
        "The young soldier glances shyly at {the adelicia/her}, then
        remarks,
        <q>Please don't be afraid, my lady, no harm will come to you
        here.</q>\b
        <q>That remains to be seen,</q> his older companion coldly
        remarks.<.p>" });
        isDone = true;
    }
;

ranulf: Person, Rapper 'lord ranulf' 'Lord Ranulf' @northWall
    desc() { "Lord Ranulf of Heningham is a small, wiry man with a face
             like a ferret's. "; }
    isProperName = true
;

+AgendaItem
    initiallyActive = true
    isReady = getActor.canTouch(gPlayerChar)
    invokeItem() {
        "<q>So, de Bredwardine,</q> Ranulf mutters to himself, <q>you
        think to cheat me of my ransom, do you? Big mistake; <i>big</i>
        mistake.</q> he adds, grinding the fist of his right hand in
        the palm of his left, <q>Let's see how much Stephen's willing
        to pay for <i>you</i>.</q> ";
        isDone = true;
    }
;

horse: Chair, Vehicle, Heavy
         'large seasoned old chestnut (war) horse/charger/war-horse'
         'chestnut horse' @battlefield
    desc = "It's a large chestnut charger - a seasoned old war-horse by
           the look of him. "
    dobjFor(SitOn) {
        check() {
            inherited();
            if (gActor != geoffrey)
                "The horse appears very well trained, and violently
                kicks all but his proper rider. ";
        }
    }
;


geoffrey: Person, Royalist, Rapper 'baron geoffrey' 'Baron Geoffrey' @horse
  desc() { "Geoffrey de Bredwardine is a large, stocky man with a florid
   complexion and unruly, red-brown hair. "; }
  isProperName = true
  posture = sitting
  endurance = 30
  NPCDies() {
       finishGameMsg('As Baron Geoffrey de Bredwardine sighs his last breath,
                      his forces retreat in confusion.\b
                      The battle for Walcot Keep has ended.',
                      [finishOptionCredits]);
  }
  initializeActor() {
    inherited();
    local x = new Sword;
    x.moveInto(self);
    wielding = x;
  }
    rIdleCode() {
        myPlan = rIn;
        myParam = chamber;
        callAnimateDaemon();
        inherited();
    }
;

+AgendaItem
  initiallyActive = true
  isReady = getActor.canTouch(gPlayerChar) &&
            getActor.isIn(battlefield)
  invokeItem
  {
    "Baron Geoffrey de Bredwardine looks up at the castle and shakes
    his fist,
     <q>So, Ranulf, my old enemy; you think to defie the king, steal my daughter,
     and demand a ransom, do you!</q> he growls, <q>Before the day's out I'll have 
     you dragged in chains before King Stephen - and then we'll see how your friends 
     feel about ransoming you - assuming Matilda is foolish enough to want you back!</q><.p>";
    isDone = true;
  }
;

// doing it this way ties the game to turn-based. The player cannot
// turn on realtime and sit back and watch the action.

+AgendaItem, EventList
  initiallyActive = true
  isReady = mainGate.isOpen
  invokeItem { doScript; }
  eventList = [
     '<q>The gate is open!</q> cries Geoffrey, <q>Forward, men, the day is ours!</q>',
     
     new function {
        geoffrey.scriptedTravelTo(road); 
        "<q>To me, men, to me!</q> Geoffrey commands.<.p>";
        foreach(local cur in battlefield.contents)
          if(cur.ofKind(Royalist)) cur.scriptedTravelTo(road);
        foreach(local cur in ditch.contents)
          if(cur.ofKind(Royalist)) cur.scriptedTravelTo(road);
     },
     
     new function {         
        "<q>Forward!</q> cries Geoffrey, <q>Let's show Lord Ranulf's bastards they're
         no match for <i>real</i> soldiers. For King Stephen and the honour of
         the de Bredwardines - forward!</q><.p>";
        geoffrey.scriptedTravelTo(courtyardNorth); 
        foreach(local cur in road.contents)
          if(cur.ofKind(Royalist)) cur.scriptedTravelTo(courtyardNorth);
     },
     
     new function {
       newActorAction(geoffrey, GetOffOf, horse);
       "Geoffrey dismounts and looks around, rallying his men to the attack. ";
       isDone = true;
//       geoffrey.addToAgenda(geoffreyBatteringAgenda);
       for (local obj = firstObj(Royalist) ; obj ; obj = nextObj(obj, Royalist)) {
           obj.myParam = obj.myEnemy;
           obj.myPlan = rFindAndAttack;
           obj.callAnimateDaemon();
       }
     }
  ]
;  

+geoffreyBatteringAgenda: AgendaItem, StopEventList
//  initiallyActive = true
  isReady = keepDoor.isLocked
  invokeItem { doScript; }
  eventList = [
    '<q>Hurry, we must gain access to the keep!</q> Geoffrey commands.\b
     <q>Lord Ranulf has locked himself in, my liege,</q> one of his
     men informs him.\b
     <q>Then we must find something to batter down the door!</q> says Geoffrey,
     <q>Let us see what we can find!</q>\b',
     
     new function() {
       if(geoffrey.isIn(courtyardNorth))
         foreach(local cur in courtyardNorth.contents)
           if(cur.ofKind(Royalist)) cur.scriptedTravelTo(courtyardSouth);
       
       "<q>Let's try in there!</q> Geoffrey decides, pointing to the kitchen.<.p>";        
     },
     
     new function() {
       foreach(local cur in courtyardSouth.contents)
         if(cur.ofKind(Royalist)) cur.scriptedTravelTo(kitchen);
     },
     
     new function() {
        
       "Geoffrey looks round the kitchen and points to the table, <q>That'll
        have to do,</q> he decides, <q>Fit that cauldron over the end as a
        cap and it may even make a half-decent ram!";
        if(geoffrey.canSee(cheese))
        {
         " In the meantime I'll deal with this...</q> So saying, the baron picks
          up the hunk of cheese and proceeds to start munching it.<.p>";
          nestedActorAction(geoffrey, Take, cheese);
          nestedActorAction(geoffrey, Eat, cheese);
        }
        else
          "</q><.p>";
        foreach(local cur in kitchen.contents)
          if(cur.ofKind(Royalist) && cur != geoffrey)
          {
            pusher = cur;
            break;
          }
        if(pusher == nil) pusher = geoffrey; 
        if(pusher.getOutermostRoom != geoffrey.getOutermostRoom)
          pusher.scriptedTravelTo(geoffrey.getOutermostRoom);
        nestedActorAction(pusher, AttachTo, cauldron, kitchenTable);
     },
     
     
    new function() {
       "<q>Right, look lively there, let's get this thing moving!</q> Geoffrey commands.<.p>";
       if(pusher.getOutermostRoom != geoffrey.getOutermostRoom)
          pusher.scriptedTravelTo(geoffrey.getOutermostRoom);
       nestedActorAction(pusher, PushNorth, kitchenTable);
       foreach(local cur in kitchen.contents)
         if(cur.ofKind(Royalist)) cur.scriptedTravelTo(courtyardSouth);
    },
    
    new function() {
      "<q>Hurry! Hurry!</q> Geoffrey urges.<.p>";
//      geoffrey.addToAgenda(geoffreyIntoKeepAgenda);
      if(pusher.getOutermostRoom != geoffrey.getOutermostRoom)
          pusher.scriptedTravelTo(geoffrey.getOutermostRoom);
      nestedActorAction(pusher, PushNorth, kitchenTable);
      foreach(local cur in courtyardSouth.contents)
         if(cur.ofKind(Royalist)) cur.scriptedTravelTo(courtyardNorth);
    },
    
    new function() {
      "<q>Put your backs into it men!</q> Geoffrey commands, <q>We'll have
       that door down in a jiffy!</q>\b
       The men with Geoffrey pick up the makeshift battering ram (the
        kitchen table with its cauldron-cap) and ram it against the
        door of the keep.<.p>";
      if(pusher.getOutermostRoom != geoffrey.getOutermostRoom)
          pusher.scriptedTravelTo(geoffrey.getOutermostRoom); 
      nestedActorAction(pusher, PushWest, kitchenTable); 
      foreach(local cur in courtyardSouth.contents)
        if(cur.ofKind(Royalist)) cur.scriptedTravelTo(courtyardNorth);
      foreach(local cur in northWall.contents) 
        if(cur.ofKind(Royalist)) cur.scriptedTravelTo(courtyardNorth);
      foreach(local cur in gatehouse.contents)
        if(cur.ofKind(Royalist)) cur.scriptedTravelTo(northWall);
      foreach(local cur in southWall.contents)  
        if(cur.ofKind(Royalist)) cur.scriptedTravelTo(gatehouse);
    }  
       
  ]
  pusher = nil
  isDone = keepDoor.isOpen
;
