#charset "us-ascii"
#include <adv3.h>
#include <en_us.h>

/*
 *
 */

modify libGlobal
    rCachePlanPath = true
;

modify Rapper
    rIdleCode() {
        self.myPlan = rAmbush;
        self.myParam = self.myEnemy;
        self.callAnimateDaemon();
        inherited();
    }

    // we begin the game with this default:

    rSwitchableAnimateDaemon = rPseudoRTAnimateDaemon
;

// initialize the map:
// (for the purposes of this demonstration, omniscience is acceptable.)

rMapInitializer: PreinitObject
    execute() {
        rMapHandler.rBuildMap(); // this is a RAP function.
    }
;

modify rFailedAction
    rAction(a,p) {
        a.rIdleCode();
    }
;

modify rObjOn
    rTrue(a, p) {
        if (p[1].ofKind(Ladder))
            return (p[2].ofKind(Wall) && p[2].getCurLadder &&
                    p[2].getCurLadder.upperEndLoc == p[2].upperEndLoc);

        return (rObjIn.rTrue(a, p));
    }
;

rMakeTowerClimbable: rStep
    rTrue(a,p) { return (seigeTower.distanceToWall == 0); }
    rPlans(a,p) {
        return [[rBe, rIn, battlefield,
                 rDo, rMakeTowerClimbable, nil]];
    }
    rAction(a,p) {
        nestedActorAction(a, Push, seigeTower);
    }
;

/*
 * modified rMovePlans for special movement between rooms.
 */

modify northWall
    rMovePlan = [
                  [rBe,rIn,gatehouse,
                   rDo,rIn,northWall],

                  [rBe,rIn,courtyardNorth,
                   rDo,rIn,northWall],

                  [rBe,rObjOn,[Ladder,fieldWall],
                   rBe,rStandOn,fieldWall.getCurLadderFunction(),
                   rDo,rIn,northWall],

                  [rBe,rObjOn,[Ladder,northCourtWall],
                   rBe,rStandOn,northCourtWall.getCurLadderFunction(),
                   rDo,rIn,northWall],

                   [rBe, rIn, battlefield,
                    rBe, rMakeTowerClimbable, nil,
                    rDo, rIn, northWall]
                ]
;

modify courtyardNorth
    rMovePlan = [
                 [rBe, rIn, stable,
                  rDo, rIn, courtyardNorth],

                 [rBe, rIn, keep,
                  rDo, rIn, courtyardNorth],

                 [rBe, rIn, courtyardSouth,
                  rDo, rIn, courtyardNorth],

                 [rBe, rIn, northWall,
                  rDo, rIn, courtyardNorth],

                 [rBe, rObjOn, [Ladder,balconyWall],
                  rBe, rStandOn, balconyWall.getCurLadderFunction(),
                  rDo, rIn, courtyardNorth],

                 [rBe, rObjOn, [Ladder,northCourtWall],
                  rBe, rStandOn, northCourtWall.getCurLadderFunction(),
                  rDo, rIn, courtyardNorth]
                ]
;

modify road
    rMovePlan = [
                 [rBe, rIn, ditch,
                  rDo, rIn, road],

                 [rBe, rIn, battlefield,
                  rDo, rIn, road]
                ]
;

/*

modify balcony
    rMovePlan = [
                   [rBe,rIn,chamber,
                    rDo,rIn,balcony],

                   [rBe,rObjOn,[Ladder,balconyWall],
                    rBe,rStandOn,balconyWall.getCurLadderFunction(),
                    rDo,rIn,balcony],

                   [rBe, rHold, rope,
                    rBe, rIn, northWall,
                    rDo, rSwing, nil]
                ]
;

rSwing: rStep
    rAction(a,p) {
        nestedActorAction(a, SwingOn, rope);
    }
;
*/

modify chimney
    rMovePlan = [
                   [rBe, rIn, kitchenRoof,
                    rBe, rNotHave, Ladder,
                    rDo, rIn, chimney],

                   [rBe, rIn, kitchen,
                    rBe, rNotHave, Ladder,
                    rDo, rIn, chimney]
                ]
;

/*
 * Customized object plans:
 */

modify mainGate
    rOpenCustomPlan = [[rBe, rIn, gatehouse, rDo, self, nil]]
    rAction(a, p) { nestedActorAction(a, Turn, wheel); }
;

modify mainGateInside
    rOpenCustomPlan = mainGate.rOpenCustomPlan
    rAction(a, p) { nestedActorAction(a, Turn, wheel); }
;

/* Add ladder movement to movement plans.
 */
rLadderMovementInit: PreinitObject
    execute() {
        local w = firstObj(Wall);
        while(w != nil) {
            if (w.upperEndLoc && w.location) {
                w.upperEndLoc.rMovePlan += [[rBe, rObjOn, [Ladder, w],
                                             rBe, rStandOn, w.getCurLadderFunction(),
                                             rDo, rIn, w.upperEndLoc]];
                w.location.rMovePlan += [[rBe, rObjOn, [Ladder, w],
                                          rBe, rStandOn, w.getCurLadderFunction(),
                                          rDo, rIn, w.location]];
            }
            w = nextObj(w, Wall);
        }
    }
    execBeforeMe = [adv3LibPreinit, rMapInitializer]
;

modify Wall
    getCurLadderFunction() { return ({:self.getCurLadder}); }
;

